"use client";
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/option.tsx
var option_exports = {};
__export(option_exports, {
  Option: () => Option
});
module.exports = __toCommonJS(option_exports);
var import_react_utils = require("@webbo-ui/react-utils");
var import_use_pointer_events = require("@webbo-ui/use-pointer-events");
var import_react = require("react");
var import_jsx_runtime = require("react/jsx-runtime");
var Option = (0, import_react.forwardRef)((props, ref) => {
  const {
    label,
    onSelect,
    onHover,
    state: { disabled, focused, selected },
    children,
    onPointerDown,
    onPointerUp,
    onPointerEnter,
    onPointerLeave,
    ...restProps
  } = props;
  const innerRef = (0, import_react.useRef)(null);
  const isHovered = (0, import_react.useRef)(false);
  const pointerEvents = (0, import_use_pointer_events.usePointerEvents)({
    onPointerDown: (e) => {
      onPointerDown?.(e);
      e.preventDefault();
    },
    onPointerUp,
    onPress: () => {
      if (disabled)
        return;
      onSelect();
    }
  });
  (0, import_react.useEffect)(() => {
    if (selected)
      innerRef.current?.scrollIntoView({
        behavior: "instant",
        block: "center"
      });
  }, [selected]);
  (0, import_react.useEffect)(() => {
    if (focused && !isHovered.current)
      innerRef.current?.scrollIntoView({
        behavior: "instant",
        block: "nearest"
      });
  }, [focused]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "li",
    {
      ref: (0, import_react_utils.mergeRefs)(ref, innerRef),
      onPointerEnter: (e) => {
        onPointerEnter?.(e);
        isHovered.current = true;
        onHover();
      },
      onPointerLeave: (e) => {
        onPointerLeave?.(e);
        isHovered.current = false;
      },
      ...pointerEvents,
      ...restProps,
      children: children ?? label
    }
  );
});
Option.displayName = "webbo-ui.Option";
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Option
});
